// original source http://mgeshaderlibrary.wikispaces.com/SSNM
// Author: peachykeen
// Title: SSNM v2
// converted by Ren712
// emboss.fx
//

//---------------------------------------------------------------------
// Settings
//---------------------------------------------------------------------
float2 rcpres = float2(0.0015,0.0015);
texture sTex0 :TEX0;

//---------------------------------------------------------------------
// Include some common stuff
//---------------------------------------------------------------------
#include "mta-helper.fx"


//---------------------------------------------------------------------
// Sampler for the main texture
//---------------------------------------------------------------------
sampler Sampler0 = sampler_state
{
    Texture = (sTex0);
	minfilter = linear; 
	magfilter = linear; 
	mipfilter = linear; 
	addressu = clamp; 
	addressv = clamp;
};


//---------------------------------------------------------------------
// Structure of data sent to the pixel shader ( from the vertex shader )
//---------------------------------------------------------------------
struct PSInput
{
  float4 Position : POSITION0;
  float4 Diffuse : COLOR0;
  float2 TexCoord : TEXCOORD0;
};


//------------------------------------------------------------------------------------------
// PixelShaderFunction
//  1. Read from PS structure
//  2. Process
//  3. Return pixel color
//------------------------------------------------------------------------------------------
float4 PixelShaderFunction(PSInput PS) : COLOR0
{
    // Get texture pixel
    float4 texcolor = tex2D(Sampler0, PS.TexCoord);
	texcolor -= tex2D(Sampler0, PS.TexCoord.xy - rcpres.xy) * 2.7f;
	texcolor += tex2D(Sampler0, PS.TexCoord.xy + rcpres.xy) * 2.7f;
	texcolor.rgb = (texcolor.r + texcolor.g + texcolor.b) / 3.0f;

    return texcolor;
}

//------------------------------------------------------------------------------------------
// Techniques
//------------------------------------------------------------------------------------------
technique tec0
{
    pass P0
    {
        PixelShader = compile ps_2_0 PixelShaderFunction();
    }
}

// Fallback
technique fallback
{
    pass P0
    {
        // Just draw normally
    }
}
